=begin
#OrderCloud

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0
Contact: ordercloud@four51.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require "uri"

module OrderCloud
  class CatalogApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end

    # 
    # 
    # @param catalog 
    # @param [Hash] opts the optional parameters
    # @return [Catalog]
    def create(catalog, opts = {})
      data, _status_code, _headers = create_with_http_info(catalog, opts)
      return data
    end

    # 
    # 
    # @param catalog 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Catalog, Fixnum, Hash)>] Catalog data, response status code and response headers
    def create_with_http_info(catalog, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: CatalogApi.create ..."
      end
      # verify the required parameter 'catalog' is set
      fail ArgumentError, "Missing the required parameter 'catalog' when calling CatalogApi.create" if catalog.nil?
      # resource path
      local_var_path = "/catalogs".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(catalog)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Catalog')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CatalogApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param catalog_id ID of the catalog.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete(catalog_id, opts = {})
      delete_with_http_info(catalog_id, opts)
      return nil
    end

    # 
    # 
    # @param catalog_id ID of the catalog.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_with_http_info(catalog_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: CatalogApi.delete ..."
      end
      # verify the required parameter 'catalog_id' is set
      fail ArgumentError, "Missing the required parameter 'catalog_id' when calling CatalogApi.delete" if catalog_id.nil?
      # resource path
      local_var_path = "/catalogs/{catalogID}".sub('{format}','json').sub('{' + 'catalogID' + '}', catalog_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CatalogApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param catalog_id ID of the catalog.
    # @param buyer_id ID of the buyer.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_assignment(catalog_id, buyer_id, opts = {})
      delete_assignment_with_http_info(catalog_id, buyer_id, opts)
      return nil
    end

    # 
    # 
    # @param catalog_id ID of the catalog.
    # @param buyer_id ID of the buyer.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_assignment_with_http_info(catalog_id, buyer_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: CatalogApi.delete_assignment ..."
      end
      # verify the required parameter 'catalog_id' is set
      fail ArgumentError, "Missing the required parameter 'catalog_id' when calling CatalogApi.delete_assignment" if catalog_id.nil?
      # verify the required parameter 'buyer_id' is set
      fail ArgumentError, "Missing the required parameter 'buyer_id' when calling CatalogApi.delete_assignment" if buyer_id.nil?
      # resource path
      local_var_path = "/catalogs/{catalogID}/assignments".sub('{format}','json').sub('{' + 'catalogID' + '}', catalog_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'buyerID'] = buyer_id

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CatalogApi#delete_assignment\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param catalog_id ID of the catalog.
    # @param product_id ID of the product.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_product_assignment(catalog_id, product_id, opts = {})
      delete_product_assignment_with_http_info(catalog_id, product_id, opts)
      return nil
    end

    # 
    # 
    # @param catalog_id ID of the catalog.
    # @param product_id ID of the product.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_product_assignment_with_http_info(catalog_id, product_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: CatalogApi.delete_product_assignment ..."
      end
      # verify the required parameter 'catalog_id' is set
      fail ArgumentError, "Missing the required parameter 'catalog_id' when calling CatalogApi.delete_product_assignment" if catalog_id.nil?
      # verify the required parameter 'product_id' is set
      fail ArgumentError, "Missing the required parameter 'product_id' when calling CatalogApi.delete_product_assignment" if product_id.nil?
      # resource path
      local_var_path = "/catalogs/{catalogID}/productassignments/{productID}".sub('{format}','json').sub('{' + 'catalogID' + '}', catalog_id.to_s).sub('{' + 'productID' + '}', product_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CatalogApi#delete_product_assignment\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param catalog_id ID of the catalog.
    # @param [Hash] opts the optional parameters
    # @return [Catalog]
    def get(catalog_id, opts = {})
      data, _status_code, _headers = get_with_http_info(catalog_id, opts)
      return data
    end

    # 
    # 
    # @param catalog_id ID of the catalog.
    # @param [Hash] opts the optional parameters
    # @return [Array<(Catalog, Fixnum, Hash)>] Catalog data, response status code and response headers
    def get_with_http_info(catalog_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: CatalogApi.get ..."
      end
      # verify the required parameter 'catalog_id' is set
      fail ArgumentError, "Missing the required parameter 'catalog_id' when calling CatalogApi.get" if catalog_id.nil?
      # resource path
      local_var_path = "/catalogs/{catalogID}".sub('{format}','json').sub('{' + 'catalogID' + '}', catalog_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Catalog')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CatalogApi#get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :search Search of the catalog.
    # @option opts [Array<String>] :search_on Search on of the catalog.
    # @option opts [Array<String>] :sort_by Sort by of the catalog.
    # @option opts [Integer] :page Page of the catalog.
    # @option opts [Integer] :page_size Page size of the catalog.
    # @option opts [Hash<String, String>] :filters Filters of the catalog.
    # @return [ListCatalog]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      return data
    end

    # 
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :search Search of the catalog.
    # @option opts [Array<String>] :search_on Search on of the catalog.
    # @option opts [Array<String>] :sort_by Sort by of the catalog.
    # @option opts [Integer] :page Page of the catalog.
    # @option opts [Integer] :page_size Page size of the catalog.
    # @option opts [Hash<String, String>] :filters Filters of the catalog.
    # @return [Array<(ListCatalog, Fixnum, Hash)>] ListCatalog data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: CatalogApi.list ..."
      end
      # resource path
      local_var_path = "/catalogs".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'search'] = opts[:'search'] if !opts[:'search'].nil?
      query_params[:'searchOn'] = @api_client.build_collection_param(opts[:'search_on'], :csv) if !opts[:'search_on'].nil?
      query_params[:'sortBy'] = @api_client.build_collection_param(opts[:'sort_by'], :csv) if !opts[:'sort_by'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'pageSize'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'filters'] = opts[:'filters'] if !opts[:'filters'].nil?

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ListCatalog')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CatalogApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :catalog_id ID of the catalog.
    # @option opts [String] :buyer_id ID of the buyer.
    # @option opts [Integer] :page Page of the catalog.
    # @option opts [Integer] :page_size Page size of the catalog.
    # @return [ListCatalogAssignment]
    def list_assignments(opts = {})
      data, _status_code, _headers = list_assignments_with_http_info(opts)
      return data
    end

    # 
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :catalog_id ID of the catalog.
    # @option opts [String] :buyer_id ID of the buyer.
    # @option opts [Integer] :page Page of the catalog.
    # @option opts [Integer] :page_size Page size of the catalog.
    # @return [Array<(ListCatalogAssignment, Fixnum, Hash)>] ListCatalogAssignment data, response status code and response headers
    def list_assignments_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: CatalogApi.list_assignments ..."
      end
      # resource path
      local_var_path = "/catalogs/assignments".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'catalogID'] = opts[:'catalog_id'] if !opts[:'catalog_id'].nil?
      query_params[:'buyerID'] = opts[:'buyer_id'] if !opts[:'buyer_id'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'pageSize'] = opts[:'page_size'] if !opts[:'page_size'].nil?

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ListCatalogAssignment')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CatalogApi#list_assignments\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :catalog_id ID of the catalog.
    # @option opts [String] :product_id ID of the product.
    # @option opts [Integer] :page Page of the catalog.
    # @option opts [Integer] :page_size Page size of the catalog.
    # @return [ListProductCatalogAssignment]
    def list_product_assignments(opts = {})
      data, _status_code, _headers = list_product_assignments_with_http_info(opts)
      return data
    end

    # 
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :catalog_id ID of the catalog.
    # @option opts [String] :product_id ID of the product.
    # @option opts [Integer] :page Page of the catalog.
    # @option opts [Integer] :page_size Page size of the catalog.
    # @return [Array<(ListProductCatalogAssignment, Fixnum, Hash)>] ListProductCatalogAssignment data, response status code and response headers
    def list_product_assignments_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: CatalogApi.list_product_assignments ..."
      end
      # resource path
      local_var_path = "/catalogs/productassignments".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'catalogID'] = opts[:'catalog_id'] if !opts[:'catalog_id'].nil?
      query_params[:'productID'] = opts[:'product_id'] if !opts[:'product_id'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'pageSize'] = opts[:'page_size'] if !opts[:'page_size'].nil?

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ListProductCatalogAssignment')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CatalogApi#list_product_assignments\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param catalog_id ID of the catalog.
    # @param partial_catalog 
    # @param [Hash] opts the optional parameters
    # @return [Catalog]
    def patch(catalog_id, partial_catalog, opts = {})
      data, _status_code, _headers = patch_with_http_info(catalog_id, partial_catalog, opts)
      return data
    end

    # 
    # 
    # @param catalog_id ID of the catalog.
    # @param partial_catalog 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Catalog, Fixnum, Hash)>] Catalog data, response status code and response headers
    def patch_with_http_info(catalog_id, partial_catalog, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: CatalogApi.patch ..."
      end
      # verify the required parameter 'catalog_id' is set
      fail ArgumentError, "Missing the required parameter 'catalog_id' when calling CatalogApi.patch" if catalog_id.nil?
      # verify the required parameter 'partial_catalog' is set
      fail ArgumentError, "Missing the required parameter 'partial_catalog' when calling CatalogApi.patch" if partial_catalog.nil?
      # resource path
      local_var_path = "/catalogs/{catalogID}".sub('{format}','json').sub('{' + 'catalogID' + '}', catalog_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(partial_catalog)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Catalog')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CatalogApi#patch\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param assignment 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def save_assignment(assignment, opts = {})
      save_assignment_with_http_info(assignment, opts)
      return nil
    end

    # 
    # 
    # @param assignment 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def save_assignment_with_http_info(assignment, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: CatalogApi.save_assignment ..."
      end
      # verify the required parameter 'assignment' is set
      fail ArgumentError, "Missing the required parameter 'assignment' when calling CatalogApi.save_assignment" if assignment.nil?
      # resource path
      local_var_path = "/catalogs/assignments".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(assignment)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CatalogApi#save_assignment\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param product_assignment 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def save_product_assignment(product_assignment, opts = {})
      save_product_assignment_with_http_info(product_assignment, opts)
      return nil
    end

    # 
    # 
    # @param product_assignment 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def save_product_assignment_with_http_info(product_assignment, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: CatalogApi.save_product_assignment ..."
      end
      # verify the required parameter 'product_assignment' is set
      fail ArgumentError, "Missing the required parameter 'product_assignment' when calling CatalogApi.save_product_assignment" if product_assignment.nil?
      # resource path
      local_var_path = "/catalogs/productassignments".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(product_assignment)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CatalogApi#save_product_assignment\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param catalog_id ID of the catalog.
    # @param catalog 
    # @param [Hash] opts the optional parameters
    # @return [Catalog]
    def update(catalog_id, catalog, opts = {})
      data, _status_code, _headers = update_with_http_info(catalog_id, catalog, opts)
      return data
    end

    # 
    # 
    # @param catalog_id ID of the catalog.
    # @param catalog 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Catalog, Fixnum, Hash)>] Catalog data, response status code and response headers
    def update_with_http_info(catalog_id, catalog, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: CatalogApi.update ..."
      end
      # verify the required parameter 'catalog_id' is set
      fail ArgumentError, "Missing the required parameter 'catalog_id' when calling CatalogApi.update" if catalog_id.nil?
      # verify the required parameter 'catalog' is set
      fail ArgumentError, "Missing the required parameter 'catalog' when calling CatalogApi.update" if catalog.nil?
      # resource path
      local_var_path = "/catalogs/{catalogID}".sub('{format}','json').sub('{' + 'catalogID' + '}', catalog_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(catalog)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Catalog')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CatalogApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
