=begin
#OrderCloud

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0
Contact: ordercloud@four51.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require "uri"

module OrderCloud
  class ImpersonationConfigApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end

    # 
    # 
    # @param impersonation_config 
    # @param [Hash] opts the optional parameters
    # @return [ImpersonationConfig]
    def create(impersonation_config, opts = {})
      data, _status_code, _headers = create_with_http_info(impersonation_config, opts)
      return data
    end

    # 
    # 
    # @param impersonation_config 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ImpersonationConfig, Fixnum, Hash)>] ImpersonationConfig data, response status code and response headers
    def create_with_http_info(impersonation_config, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ImpersonationConfigApi.create ..."
      end
      # verify the required parameter 'impersonation_config' is set
      fail ArgumentError, "Missing the required parameter 'impersonation_config' when calling ImpersonationConfigApi.create" if impersonation_config.nil?
      # resource path
      local_var_path = "/impersonationconfig".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(impersonation_config)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ImpersonationConfig')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImpersonationConfigApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param impersonation_config_id ID of the impersonation config.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete(impersonation_config_id, opts = {})
      delete_with_http_info(impersonation_config_id, opts)
      return nil
    end

    # 
    # 
    # @param impersonation_config_id ID of the impersonation config.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_with_http_info(impersonation_config_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ImpersonationConfigApi.delete ..."
      end
      # verify the required parameter 'impersonation_config_id' is set
      fail ArgumentError, "Missing the required parameter 'impersonation_config_id' when calling ImpersonationConfigApi.delete" if impersonation_config_id.nil?
      # resource path
      local_var_path = "/impersonationconfig/{impersonationConfigID}".sub('{format}','json').sub('{' + 'impersonationConfigID' + '}', impersonation_config_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImpersonationConfigApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param impersonation_config_id ID of the impersonation config.
    # @param [Hash] opts the optional parameters
    # @return [ImpersonationConfig]
    def get(impersonation_config_id, opts = {})
      data, _status_code, _headers = get_with_http_info(impersonation_config_id, opts)
      return data
    end

    # 
    # 
    # @param impersonation_config_id ID of the impersonation config.
    # @param [Hash] opts the optional parameters
    # @return [Array<(ImpersonationConfig, Fixnum, Hash)>] ImpersonationConfig data, response status code and response headers
    def get_with_http_info(impersonation_config_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ImpersonationConfigApi.get ..."
      end
      # verify the required parameter 'impersonation_config_id' is set
      fail ArgumentError, "Missing the required parameter 'impersonation_config_id' when calling ImpersonationConfigApi.get" if impersonation_config_id.nil?
      # resource path
      local_var_path = "/impersonationconfig/{impersonationConfigID}".sub('{format}','json').sub('{' + 'impersonationConfigID' + '}', impersonation_config_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ImpersonationConfig')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImpersonationConfigApi#get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :search Search of the impersonation config.
    # @option opts [Array<String>] :search_on Search on of the impersonation config.
    # @option opts [Array<String>] :sort_by Sort by of the impersonation config.
    # @option opts [Integer] :page Page of the impersonation config.
    # @option opts [Integer] :page_size Page size of the impersonation config.
    # @option opts [Hash<String, String>] :filters Filters of the impersonation config.
    # @return [ListImpersonationConfig]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      return data
    end

    # 
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :search Search of the impersonation config.
    # @option opts [Array<String>] :search_on Search on of the impersonation config.
    # @option opts [Array<String>] :sort_by Sort by of the impersonation config.
    # @option opts [Integer] :page Page of the impersonation config.
    # @option opts [Integer] :page_size Page size of the impersonation config.
    # @option opts [Hash<String, String>] :filters Filters of the impersonation config.
    # @return [Array<(ListImpersonationConfig, Fixnum, Hash)>] ListImpersonationConfig data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ImpersonationConfigApi.list ..."
      end
      # resource path
      local_var_path = "/impersonationconfig".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'search'] = opts[:'search'] if !opts[:'search'].nil?
      query_params[:'searchOn'] = @api_client.build_collection_param(opts[:'search_on'], :csv) if !opts[:'search_on'].nil?
      query_params[:'sortBy'] = @api_client.build_collection_param(opts[:'sort_by'], :csv) if !opts[:'sort_by'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'pageSize'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'filters'] = opts[:'filters'] if !opts[:'filters'].nil?

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ListImpersonationConfig')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImpersonationConfigApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param impersonation_config_id ID of the impersonation config.
    # @param impersonation_config 
    # @param [Hash] opts the optional parameters
    # @return [ImpersonationConfig]
    def patch(impersonation_config_id, impersonation_config, opts = {})
      data, _status_code, _headers = patch_with_http_info(impersonation_config_id, impersonation_config, opts)
      return data
    end

    # 
    # 
    # @param impersonation_config_id ID of the impersonation config.
    # @param impersonation_config 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ImpersonationConfig, Fixnum, Hash)>] ImpersonationConfig data, response status code and response headers
    def patch_with_http_info(impersonation_config_id, impersonation_config, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ImpersonationConfigApi.patch ..."
      end
      # verify the required parameter 'impersonation_config_id' is set
      fail ArgumentError, "Missing the required parameter 'impersonation_config_id' when calling ImpersonationConfigApi.patch" if impersonation_config_id.nil?
      # verify the required parameter 'impersonation_config' is set
      fail ArgumentError, "Missing the required parameter 'impersonation_config' when calling ImpersonationConfigApi.patch" if impersonation_config.nil?
      # resource path
      local_var_path = "/impersonationconfig/{impersonationConfigID}".sub('{format}','json').sub('{' + 'impersonationConfigID' + '}', impersonation_config_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(impersonation_config)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ImpersonationConfig')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImpersonationConfigApi#patch\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param impersonation_config_id ID of the impersonation config.
    # @param impersonation_config 
    # @param [Hash] opts the optional parameters
    # @return [ImpersonationConfig]
    def update(impersonation_config_id, impersonation_config, opts = {})
      data, _status_code, _headers = update_with_http_info(impersonation_config_id, impersonation_config, opts)
      return data
    end

    # 
    # 
    # @param impersonation_config_id ID of the impersonation config.
    # @param impersonation_config 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ImpersonationConfig, Fixnum, Hash)>] ImpersonationConfig data, response status code and response headers
    def update_with_http_info(impersonation_config_id, impersonation_config, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ImpersonationConfigApi.update ..."
      end
      # verify the required parameter 'impersonation_config_id' is set
      fail ArgumentError, "Missing the required parameter 'impersonation_config_id' when calling ImpersonationConfigApi.update" if impersonation_config_id.nil?
      # verify the required parameter 'impersonation_config' is set
      fail ArgumentError, "Missing the required parameter 'impersonation_config' when calling ImpersonationConfigApi.update" if impersonation_config.nil?
      # resource path
      local_var_path = "/impersonationconfig/{impersonationConfigID}".sub('{format}','json').sub('{' + 'impersonationConfigID' + '}', impersonation_config_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(impersonation_config)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ImpersonationConfig')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImpersonationConfigApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
