=begin
#OrderCloud

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0
Contact: ordercloud@four51.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require "uri"

module OrderCloud
  class PasswordResetApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end

    # 
    # 
    # @param verification_code Verification code of the forgotten password.
    # @param password_reset 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def reset_password_by_verification_code(verification_code, password_reset, opts = {})
      reset_password_by_verification_code_with_http_info(verification_code, password_reset, opts)
      return nil
    end

    # 
    # 
    # @param verification_code Verification code of the forgotten password.
    # @param password_reset 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def reset_password_by_verification_code_with_http_info(verification_code, password_reset, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PasswordResetApi.reset_password_by_verification_code ..."
      end
      # verify the required parameter 'verification_code' is set
      fail ArgumentError, "Missing the required parameter 'verification_code' when calling PasswordResetApi.reset_password_by_verification_code" if verification_code.nil?
      # verify the required parameter 'password_reset' is set
      fail ArgumentError, "Missing the required parameter 'password_reset' when calling PasswordResetApi.reset_password_by_verification_code" if password_reset.nil?
      # resource path
      local_var_path = "/password/reset/{verificationCode}".sub('{format}','json').sub('{' + 'verificationCode' + '}', verification_code.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(password_reset)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PasswordResetApi#reset_password_by_verification_code\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param password_reset_request 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def send_verification_code(password_reset_request, opts = {})
      send_verification_code_with_http_info(password_reset_request, opts)
      return nil
    end

    # 
    # 
    # @param password_reset_request 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def send_verification_code_with_http_info(password_reset_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PasswordResetApi.send_verification_code ..."
      end
      # verify the required parameter 'password_reset_request' is set
      fail ArgumentError, "Missing the required parameter 'password_reset_request' when calling PasswordResetApi.send_verification_code" if password_reset_request.nil?
      # resource path
      local_var_path = "/password/reset".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(password_reset_request)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PasswordResetApi#send_verification_code\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
