=begin
#OrderCloud

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0
Contact: ordercloud@four51.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require "uri"

module OrderCloud
  class ProductApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end

    # 
    # 
    # @param product 
    # @param [Hash] opts the optional parameters
    # @return [Product]
    def create(product, opts = {})
      data, _status_code, _headers = create_with_http_info(product, opts)
      return data
    end

    # 
    # 
    # @param product 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Product, Fixnum, Hash)>] Product data, response status code and response headers
    def create_with_http_info(product, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProductApi.create ..."
      end
      # verify the required parameter 'product' is set
      fail ArgumentError, "Missing the required parameter 'product' when calling ProductApi.create" if product.nil?
      # resource path
      local_var_path = "/products".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(product)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Product')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProductApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param product_id ID of the product.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete(product_id, opts = {})
      delete_with_http_info(product_id, opts)
      return nil
    end

    # 
    # 
    # @param product_id ID of the product.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_with_http_info(product_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProductApi.delete ..."
      end
      # verify the required parameter 'product_id' is set
      fail ArgumentError, "Missing the required parameter 'product_id' when calling ProductApi.delete" if product_id.nil?
      # resource path
      local_var_path = "/products/{productID}".sub('{format}','json').sub('{' + 'productID' + '}', product_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProductApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param product_id ID of the product.
    # @param buyer_id ID of the buyer.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :user_id ID of the user.
    # @option opts [String] :user_group_id ID of the user group.
    # @return [nil]
    def delete_assignment(product_id, buyer_id, opts = {})
      delete_assignment_with_http_info(product_id, buyer_id, opts)
      return nil
    end

    # 
    # 
    # @param product_id ID of the product.
    # @param buyer_id ID of the buyer.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :user_id ID of the user.
    # @option opts [String] :user_group_id ID of the user group.
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_assignment_with_http_info(product_id, buyer_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProductApi.delete_assignment ..."
      end
      # verify the required parameter 'product_id' is set
      fail ArgumentError, "Missing the required parameter 'product_id' when calling ProductApi.delete_assignment" if product_id.nil?
      # verify the required parameter 'buyer_id' is set
      fail ArgumentError, "Missing the required parameter 'buyer_id' when calling ProductApi.delete_assignment" if buyer_id.nil?
      # resource path
      local_var_path = "/products/{productID}/assignments/{buyerID}".sub('{format}','json').sub('{' + 'productID' + '}', product_id.to_s).sub('{' + 'buyerID' + '}', buyer_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'userID'] = opts[:'user_id'] if !opts[:'user_id'].nil?
      query_params[:'userGroupID'] = opts[:'user_group_id'] if !opts[:'user_group_id'].nil?

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProductApi#delete_assignment\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param product_id ID of the product.
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :overwrite_existing Overwrite existing of the product.
    # @return [Product]
    def generate_variants(product_id, opts = {})
      data, _status_code, _headers = generate_variants_with_http_info(product_id, opts)
      return data
    end

    # 
    # 
    # @param product_id ID of the product.
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :overwrite_existing Overwrite existing of the product.
    # @return [Array<(Product, Fixnum, Hash)>] Product data, response status code and response headers
    def generate_variants_with_http_info(product_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProductApi.generate_variants ..."
      end
      # verify the required parameter 'product_id' is set
      fail ArgumentError, "Missing the required parameter 'product_id' when calling ProductApi.generate_variants" if product_id.nil?
      # resource path
      local_var_path = "/products/{productID}/variants/generate".sub('{format}','json').sub('{' + 'productID' + '}', product_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'overwriteExisting'] = opts[:'overwrite_existing'] if !opts[:'overwrite_existing'].nil?

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Product')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProductApi#generate_variants\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param product_id ID of the product.
    # @param [Hash] opts the optional parameters
    # @return [Product]
    def get(product_id, opts = {})
      data, _status_code, _headers = get_with_http_info(product_id, opts)
      return data
    end

    # 
    # 
    # @param product_id ID of the product.
    # @param [Hash] opts the optional parameters
    # @return [Array<(Product, Fixnum, Hash)>] Product data, response status code and response headers
    def get_with_http_info(product_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProductApi.get ..."
      end
      # verify the required parameter 'product_id' is set
      fail ArgumentError, "Missing the required parameter 'product_id' when calling ProductApi.get" if product_id.nil?
      # resource path
      local_var_path = "/products/{productID}".sub('{format}','json').sub('{' + 'productID' + '}', product_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Product')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProductApi#get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param product_id ID of the product.
    # @param variant_id ID of the variant.
    # @param [Hash] opts the optional parameters
    # @return [Variant]
    def get_variant(product_id, variant_id, opts = {})
      data, _status_code, _headers = get_variant_with_http_info(product_id, variant_id, opts)
      return data
    end

    # 
    # 
    # @param product_id ID of the product.
    # @param variant_id ID of the variant.
    # @param [Hash] opts the optional parameters
    # @return [Array<(Variant, Fixnum, Hash)>] Variant data, response status code and response headers
    def get_variant_with_http_info(product_id, variant_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProductApi.get_variant ..."
      end
      # verify the required parameter 'product_id' is set
      fail ArgumentError, "Missing the required parameter 'product_id' when calling ProductApi.get_variant" if product_id.nil?
      # verify the required parameter 'variant_id' is set
      fail ArgumentError, "Missing the required parameter 'variant_id' when calling ProductApi.get_variant" if variant_id.nil?
      # resource path
      local_var_path = "/products/{productID}/variants/{variantID}".sub('{format}','json').sub('{' + 'productID' + '}', product_id.to_s).sub('{' + 'variantID' + '}', variant_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Variant')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProductApi#get_variant\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :catalog_id ID of the catalog.
    # @option opts [String] :category_id ID of the category.
    # @option opts [String] :supplier_id ID of the supplier.
    # @option opts [String] :search Search of the product.
    # @option opts [Array<String>] :search_on Search on of the product.
    # @option opts [Array<String>] :sort_by Sort by of the product.
    # @option opts [Integer] :page Page of the product.
    # @option opts [Integer] :page_size Page size of the product.
    # @option opts [Hash<String, String>] :filters Filters of the product.
    # @return [ListProduct]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      return data
    end

    # 
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :catalog_id ID of the catalog.
    # @option opts [String] :category_id ID of the category.
    # @option opts [String] :supplier_id ID of the supplier.
    # @option opts [String] :search Search of the product.
    # @option opts [Array<String>] :search_on Search on of the product.
    # @option opts [Array<String>] :sort_by Sort by of the product.
    # @option opts [Integer] :page Page of the product.
    # @option opts [Integer] :page_size Page size of the product.
    # @option opts [Hash<String, String>] :filters Filters of the product.
    # @return [Array<(ListProduct, Fixnum, Hash)>] ListProduct data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProductApi.list ..."
      end
      # resource path
      local_var_path = "/products".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'catalogID'] = opts[:'catalog_id'] if !opts[:'catalog_id'].nil?
      query_params[:'categoryID'] = opts[:'category_id'] if !opts[:'category_id'].nil?
      query_params[:'supplierID'] = opts[:'supplier_id'] if !opts[:'supplier_id'].nil?
      query_params[:'search'] = opts[:'search'] if !opts[:'search'].nil?
      query_params[:'searchOn'] = @api_client.build_collection_param(opts[:'search_on'], :csv) if !opts[:'search_on'].nil?
      query_params[:'sortBy'] = @api_client.build_collection_param(opts[:'sort_by'], :csv) if !opts[:'sort_by'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'pageSize'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'filters'] = opts[:'filters'] if !opts[:'filters'].nil?

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ListProduct')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProductApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :product_id ID of the product.
    # @option opts [String] :price_schedule_id ID of the price schedule.
    # @option opts [String] :buyer_id ID of the buyer.
    # @option opts [String] :user_id ID of the user.
    # @option opts [String] :user_group_id ID of the user group.
    # @option opts [String] :level Level of the product.
    # @option opts [Integer] :page Page of the product.
    # @option opts [Integer] :page_size Page size of the product.
    # @return [ListProductAssignment]
    def list_assignments(opts = {})
      data, _status_code, _headers = list_assignments_with_http_info(opts)
      return data
    end

    # 
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :product_id ID of the product.
    # @option opts [String] :price_schedule_id ID of the price schedule.
    # @option opts [String] :buyer_id ID of the buyer.
    # @option opts [String] :user_id ID of the user.
    # @option opts [String] :user_group_id ID of the user group.
    # @option opts [String] :level Level of the product.
    # @option opts [Integer] :page Page of the product.
    # @option opts [Integer] :page_size Page size of the product.
    # @return [Array<(ListProductAssignment, Fixnum, Hash)>] ListProductAssignment data, response status code and response headers
    def list_assignments_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProductApi.list_assignments ..."
      end
      # resource path
      local_var_path = "/products/assignments".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'productID'] = opts[:'product_id'] if !opts[:'product_id'].nil?
      query_params[:'priceScheduleID'] = opts[:'price_schedule_id'] if !opts[:'price_schedule_id'].nil?
      query_params[:'buyerID'] = opts[:'buyer_id'] if !opts[:'buyer_id'].nil?
      query_params[:'userID'] = opts[:'user_id'] if !opts[:'user_id'].nil?
      query_params[:'userGroupID'] = opts[:'user_group_id'] if !opts[:'user_group_id'].nil?
      query_params[:'level'] = opts[:'level'] if !opts[:'level'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'pageSize'] = opts[:'page_size'] if !opts[:'page_size'].nil?

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ListProductAssignment')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProductApi#list_assignments\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param product_id ID of the product.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :search Search of the product.
    # @option opts [Array<String>] :search_on Search on of the product.
    # @option opts [Array<String>] :sort_by Sort by of the product.
    # @option opts [Integer] :page Page of the product.
    # @option opts [Integer] :page_size Page size of the product.
    # @option opts [Hash<String, String>] :filters Filters of the product.
    # @return [ListSupplier]
    def list_suppliers(product_id, opts = {})
      data, _status_code, _headers = list_suppliers_with_http_info(product_id, opts)
      return data
    end

    # 
    # 
    # @param product_id ID of the product.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :search Search of the product.
    # @option opts [Array<String>] :search_on Search on of the product.
    # @option opts [Array<String>] :sort_by Sort by of the product.
    # @option opts [Integer] :page Page of the product.
    # @option opts [Integer] :page_size Page size of the product.
    # @option opts [Hash<String, String>] :filters Filters of the product.
    # @return [Array<(ListSupplier, Fixnum, Hash)>] ListSupplier data, response status code and response headers
    def list_suppliers_with_http_info(product_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProductApi.list_suppliers ..."
      end
      # verify the required parameter 'product_id' is set
      fail ArgumentError, "Missing the required parameter 'product_id' when calling ProductApi.list_suppliers" if product_id.nil?
      # resource path
      local_var_path = "/products/{productID}/suppliers".sub('{format}','json').sub('{' + 'productID' + '}', product_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'search'] = opts[:'search'] if !opts[:'search'].nil?
      query_params[:'searchOn'] = @api_client.build_collection_param(opts[:'search_on'], :csv) if !opts[:'search_on'].nil?
      query_params[:'sortBy'] = @api_client.build_collection_param(opts[:'sort_by'], :csv) if !opts[:'sort_by'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'pageSize'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'filters'] = opts[:'filters'] if !opts[:'filters'].nil?

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ListSupplier')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProductApi#list_suppliers\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param product_id ID of the product.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :search Search of the product.
    # @option opts [Array<String>] :search_on Search on of the product.
    # @option opts [Array<String>] :sort_by Sort by of the product.
    # @option opts [Integer] :page Page of the product.
    # @option opts [Integer] :page_size Page size of the product.
    # @option opts [Hash<String, String>] :filters Filters of the product.
    # @return [ListVariant]
    def list_variants(product_id, opts = {})
      data, _status_code, _headers = list_variants_with_http_info(product_id, opts)
      return data
    end

    # 
    # 
    # @param product_id ID of the product.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :search Search of the product.
    # @option opts [Array<String>] :search_on Search on of the product.
    # @option opts [Array<String>] :sort_by Sort by of the product.
    # @option opts [Integer] :page Page of the product.
    # @option opts [Integer] :page_size Page size of the product.
    # @option opts [Hash<String, String>] :filters Filters of the product.
    # @return [Array<(ListVariant, Fixnum, Hash)>] ListVariant data, response status code and response headers
    def list_variants_with_http_info(product_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProductApi.list_variants ..."
      end
      # verify the required parameter 'product_id' is set
      fail ArgumentError, "Missing the required parameter 'product_id' when calling ProductApi.list_variants" if product_id.nil?
      # resource path
      local_var_path = "/products/{productID}/variants".sub('{format}','json').sub('{' + 'productID' + '}', product_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'search'] = opts[:'search'] if !opts[:'search'].nil?
      query_params[:'searchOn'] = @api_client.build_collection_param(opts[:'search_on'], :csv) if !opts[:'search_on'].nil?
      query_params[:'sortBy'] = @api_client.build_collection_param(opts[:'sort_by'], :csv) if !opts[:'sort_by'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'pageSize'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'filters'] = opts[:'filters'] if !opts[:'filters'].nil?

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ListVariant')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProductApi#list_variants\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param product_id ID of the product.
    # @param product 
    # @param [Hash] opts the optional parameters
    # @return [Product]
    def patch(product_id, product, opts = {})
      data, _status_code, _headers = patch_with_http_info(product_id, product, opts)
      return data
    end

    # 
    # 
    # @param product_id ID of the product.
    # @param product 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Product, Fixnum, Hash)>] Product data, response status code and response headers
    def patch_with_http_info(product_id, product, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProductApi.patch ..."
      end
      # verify the required parameter 'product_id' is set
      fail ArgumentError, "Missing the required parameter 'product_id' when calling ProductApi.patch" if product_id.nil?
      # verify the required parameter 'product' is set
      fail ArgumentError, "Missing the required parameter 'product' when calling ProductApi.patch" if product.nil?
      # resource path
      local_var_path = "/products/{productID}".sub('{format}','json').sub('{' + 'productID' + '}', product_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(product)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Product')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProductApi#patch\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param product_id ID of the product.
    # @param variant_id ID of the variant.
    # @param variant 
    # @param [Hash] opts the optional parameters
    # @return [Variant]
    def patch_variant(product_id, variant_id, variant, opts = {})
      data, _status_code, _headers = patch_variant_with_http_info(product_id, variant_id, variant, opts)
      return data
    end

    # 
    # 
    # @param product_id ID of the product.
    # @param variant_id ID of the variant.
    # @param variant 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Variant, Fixnum, Hash)>] Variant data, response status code and response headers
    def patch_variant_with_http_info(product_id, variant_id, variant, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProductApi.patch_variant ..."
      end
      # verify the required parameter 'product_id' is set
      fail ArgumentError, "Missing the required parameter 'product_id' when calling ProductApi.patch_variant" if product_id.nil?
      # verify the required parameter 'variant_id' is set
      fail ArgumentError, "Missing the required parameter 'variant_id' when calling ProductApi.patch_variant" if variant_id.nil?
      # verify the required parameter 'variant' is set
      fail ArgumentError, "Missing the required parameter 'variant' when calling ProductApi.patch_variant" if variant.nil?
      # resource path
      local_var_path = "/products/{productID}/variants/{variantID}".sub('{format}','json').sub('{' + 'productID' + '}', product_id.to_s).sub('{' + 'variantID' + '}', variant_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(variant)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Variant')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProductApi#patch_variant\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param product_id ID of the product.
    # @param supplier_id ID of the supplier.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def remove_supplier(product_id, supplier_id, opts = {})
      remove_supplier_with_http_info(product_id, supplier_id, opts)
      return nil
    end

    # 
    # 
    # @param product_id ID of the product.
    # @param supplier_id ID of the supplier.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def remove_supplier_with_http_info(product_id, supplier_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProductApi.remove_supplier ..."
      end
      # verify the required parameter 'product_id' is set
      fail ArgumentError, "Missing the required parameter 'product_id' when calling ProductApi.remove_supplier" if product_id.nil?
      # verify the required parameter 'supplier_id' is set
      fail ArgumentError, "Missing the required parameter 'supplier_id' when calling ProductApi.remove_supplier" if supplier_id.nil?
      # resource path
      local_var_path = "/products/{productID}/suppliers/{supplierID}".sub('{format}','json').sub('{' + 'productID' + '}', product_id.to_s).sub('{' + 'supplierID' + '}', supplier_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProductApi#remove_supplier\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param product_assignment 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def save_assignment(product_assignment, opts = {})
      save_assignment_with_http_info(product_assignment, opts)
      return nil
    end

    # 
    # 
    # @param product_assignment 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def save_assignment_with_http_info(product_assignment, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProductApi.save_assignment ..."
      end
      # verify the required parameter 'product_assignment' is set
      fail ArgumentError, "Missing the required parameter 'product_assignment' when calling ProductApi.save_assignment" if product_assignment.nil?
      # resource path
      local_var_path = "/products/assignments".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(product_assignment)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProductApi#save_assignment\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param product_id ID of the product.
    # @param supplier_id ID of the supplier.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def save_supplier(product_id, supplier_id, opts = {})
      save_supplier_with_http_info(product_id, supplier_id, opts)
      return nil
    end

    # 
    # 
    # @param product_id ID of the product.
    # @param supplier_id ID of the supplier.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def save_supplier_with_http_info(product_id, supplier_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProductApi.save_supplier ..."
      end
      # verify the required parameter 'product_id' is set
      fail ArgumentError, "Missing the required parameter 'product_id' when calling ProductApi.save_supplier" if product_id.nil?
      # verify the required parameter 'supplier_id' is set
      fail ArgumentError, "Missing the required parameter 'supplier_id' when calling ProductApi.save_supplier" if supplier_id.nil?
      # resource path
      local_var_path = "/products/{productID}/suppliers/{supplierID}".sub('{format}','json').sub('{' + 'productID' + '}', product_id.to_s).sub('{' + 'supplierID' + '}', supplier_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProductApi#save_supplier\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param product_id ID of the product.
    # @param product 
    # @param [Hash] opts the optional parameters
    # @return [Product]
    def update(product_id, product, opts = {})
      data, _status_code, _headers = update_with_http_info(product_id, product, opts)
      return data
    end

    # 
    # 
    # @param product_id ID of the product.
    # @param product 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Product, Fixnum, Hash)>] Product data, response status code and response headers
    def update_with_http_info(product_id, product, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProductApi.update ..."
      end
      # verify the required parameter 'product_id' is set
      fail ArgumentError, "Missing the required parameter 'product_id' when calling ProductApi.update" if product_id.nil?
      # verify the required parameter 'product' is set
      fail ArgumentError, "Missing the required parameter 'product' when calling ProductApi.update" if product.nil?
      # resource path
      local_var_path = "/products/{productID}".sub('{format}','json').sub('{' + 'productID' + '}', product_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(product)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Product')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProductApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param product_id ID of the product.
    # @param variant_id ID of the variant.
    # @param variant 
    # @param [Hash] opts the optional parameters
    # @return [Variant]
    def update_variant(product_id, variant_id, variant, opts = {})
      data, _status_code, _headers = update_variant_with_http_info(product_id, variant_id, variant, opts)
      return data
    end

    # 
    # 
    # @param product_id ID of the product.
    # @param variant_id ID of the variant.
    # @param variant 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Variant, Fixnum, Hash)>] Variant data, response status code and response headers
    def update_variant_with_http_info(product_id, variant_id, variant, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProductApi.update_variant ..."
      end
      # verify the required parameter 'product_id' is set
      fail ArgumentError, "Missing the required parameter 'product_id' when calling ProductApi.update_variant" if product_id.nil?
      # verify the required parameter 'variant_id' is set
      fail ArgumentError, "Missing the required parameter 'variant_id' when calling ProductApi.update_variant" if variant_id.nil?
      # verify the required parameter 'variant' is set
      fail ArgumentError, "Missing the required parameter 'variant' when calling ProductApi.update_variant" if variant.nil?
      # resource path
      local_var_path = "/products/{productID}/variants/{variantID}".sub('{format}','json').sub('{' + 'productID' + '}', product_id.to_s).sub('{' + 'variantID' + '}', variant_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(variant)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Variant')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProductApi#update_variant\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
