=begin
#OrderCloud

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0
Contact: ordercloud@four51.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require "uri"

module OrderCloud
  class SupplierUserApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end

    # 
    # 
    # @param supplier_id ID of the supplier.
    # @param user 
    # @param [Hash] opts the optional parameters
    # @return [User]
    def create(supplier_id, user, opts = {})
      data, _status_code, _headers = create_with_http_info(supplier_id, user, opts)
      return data
    end

    # 
    # 
    # @param supplier_id ID of the supplier.
    # @param user 
    # @param [Hash] opts the optional parameters
    # @return [Array<(User, Fixnum, Hash)>] User data, response status code and response headers
    def create_with_http_info(supplier_id, user, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: SupplierUserApi.create ..."
      end
      # verify the required parameter 'supplier_id' is set
      fail ArgumentError, "Missing the required parameter 'supplier_id' when calling SupplierUserApi.create" if supplier_id.nil?
      # verify the required parameter 'user' is set
      fail ArgumentError, "Missing the required parameter 'user' when calling SupplierUserApi.create" if user.nil?
      # resource path
      local_var_path = "/suppliers/{supplierID}/users".sub('{format}','json').sub('{' + 'supplierID' + '}', supplier_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(user)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'User')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: SupplierUserApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param supplier_id ID of the supplier.
    # @param user_id ID of the user.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete(supplier_id, user_id, opts = {})
      delete_with_http_info(supplier_id, user_id, opts)
      return nil
    end

    # 
    # 
    # @param supplier_id ID of the supplier.
    # @param user_id ID of the user.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_with_http_info(supplier_id, user_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: SupplierUserApi.delete ..."
      end
      # verify the required parameter 'supplier_id' is set
      fail ArgumentError, "Missing the required parameter 'supplier_id' when calling SupplierUserApi.delete" if supplier_id.nil?
      # verify the required parameter 'user_id' is set
      fail ArgumentError, "Missing the required parameter 'user_id' when calling SupplierUserApi.delete" if user_id.nil?
      # resource path
      local_var_path = "/suppliers/{supplierID}/users/{userID}".sub('{format}','json').sub('{' + 'supplierID' + '}', supplier_id.to_s).sub('{' + 'userID' + '}', user_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: SupplierUserApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param supplier_id ID of the supplier.
    # @param user_id ID of the user.
    # @param [Hash] opts the optional parameters
    # @return [User]
    def get(supplier_id, user_id, opts = {})
      data, _status_code, _headers = get_with_http_info(supplier_id, user_id, opts)
      return data
    end

    # 
    # 
    # @param supplier_id ID of the supplier.
    # @param user_id ID of the user.
    # @param [Hash] opts the optional parameters
    # @return [Array<(User, Fixnum, Hash)>] User data, response status code and response headers
    def get_with_http_info(supplier_id, user_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: SupplierUserApi.get ..."
      end
      # verify the required parameter 'supplier_id' is set
      fail ArgumentError, "Missing the required parameter 'supplier_id' when calling SupplierUserApi.get" if supplier_id.nil?
      # verify the required parameter 'user_id' is set
      fail ArgumentError, "Missing the required parameter 'user_id' when calling SupplierUserApi.get" if user_id.nil?
      # resource path
      local_var_path = "/suppliers/{supplierID}/users/{userID}".sub('{format}','json').sub('{' + 'supplierID' + '}', supplier_id.to_s).sub('{' + 'userID' + '}', user_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'User')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: SupplierUserApi#get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param supplier_id ID of the supplier.
    # @param user_id ID of the user.
    # @param token_request 
    # @param [Hash] opts the optional parameters
    # @return [AccessToken]
    def get_access_token(supplier_id, user_id, token_request, opts = {})
      data, _status_code, _headers = get_access_token_with_http_info(supplier_id, user_id, token_request, opts)
      return data
    end

    # 
    # 
    # @param supplier_id ID of the supplier.
    # @param user_id ID of the user.
    # @param token_request 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AccessToken, Fixnum, Hash)>] AccessToken data, response status code and response headers
    def get_access_token_with_http_info(supplier_id, user_id, token_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: SupplierUserApi.get_access_token ..."
      end
      # verify the required parameter 'supplier_id' is set
      fail ArgumentError, "Missing the required parameter 'supplier_id' when calling SupplierUserApi.get_access_token" if supplier_id.nil?
      # verify the required parameter 'user_id' is set
      fail ArgumentError, "Missing the required parameter 'user_id' when calling SupplierUserApi.get_access_token" if user_id.nil?
      # verify the required parameter 'token_request' is set
      fail ArgumentError, "Missing the required parameter 'token_request' when calling SupplierUserApi.get_access_token" if token_request.nil?
      # resource path
      local_var_path = "/suppliers/{supplierID}/users/{userID}/accesstoken".sub('{format}','json').sub('{' + 'supplierID' + '}', supplier_id.to_s).sub('{' + 'userID' + '}', user_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(token_request)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AccessToken')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: SupplierUserApi#get_access_token\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param supplier_id ID of the supplier.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :user_group_id ID of the user group.
    # @option opts [String] :search Search of the supplier user.
    # @option opts [Array<String>] :search_on Search on of the supplier user.
    # @option opts [Array<String>] :sort_by Sort by of the supplier user.
    # @option opts [Integer] :page Page of the supplier user.
    # @option opts [Integer] :page_size Page size of the supplier user.
    # @option opts [Hash<String, String>] :filters Filters of the supplier user.
    # @return [ListUser]
    def list(supplier_id, opts = {})
      data, _status_code, _headers = list_with_http_info(supplier_id, opts)
      return data
    end

    # 
    # 
    # @param supplier_id ID of the supplier.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :user_group_id ID of the user group.
    # @option opts [String] :search Search of the supplier user.
    # @option opts [Array<String>] :search_on Search on of the supplier user.
    # @option opts [Array<String>] :sort_by Sort by of the supplier user.
    # @option opts [Integer] :page Page of the supplier user.
    # @option opts [Integer] :page_size Page size of the supplier user.
    # @option opts [Hash<String, String>] :filters Filters of the supplier user.
    # @return [Array<(ListUser, Fixnum, Hash)>] ListUser data, response status code and response headers
    def list_with_http_info(supplier_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: SupplierUserApi.list ..."
      end
      # verify the required parameter 'supplier_id' is set
      fail ArgumentError, "Missing the required parameter 'supplier_id' when calling SupplierUserApi.list" if supplier_id.nil?
      # resource path
      local_var_path = "/suppliers/{supplierID}/users".sub('{format}','json').sub('{' + 'supplierID' + '}', supplier_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'userGroupID'] = opts[:'user_group_id'] if !opts[:'user_group_id'].nil?
      query_params[:'search'] = opts[:'search'] if !opts[:'search'].nil?
      query_params[:'searchOn'] = @api_client.build_collection_param(opts[:'search_on'], :csv) if !opts[:'search_on'].nil?
      query_params[:'sortBy'] = @api_client.build_collection_param(opts[:'sort_by'], :csv) if !opts[:'sort_by'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'pageSize'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'filters'] = opts[:'filters'] if !opts[:'filters'].nil?

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ListUser')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: SupplierUserApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param supplier_id ID of the supplier.
    # @param user_id ID of the user.
    # @param user 
    # @param [Hash] opts the optional parameters
    # @return [User]
    def patch(supplier_id, user_id, user, opts = {})
      data, _status_code, _headers = patch_with_http_info(supplier_id, user_id, user, opts)
      return data
    end

    # 
    # 
    # @param supplier_id ID of the supplier.
    # @param user_id ID of the user.
    # @param user 
    # @param [Hash] opts the optional parameters
    # @return [Array<(User, Fixnum, Hash)>] User data, response status code and response headers
    def patch_with_http_info(supplier_id, user_id, user, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: SupplierUserApi.patch ..."
      end
      # verify the required parameter 'supplier_id' is set
      fail ArgumentError, "Missing the required parameter 'supplier_id' when calling SupplierUserApi.patch" if supplier_id.nil?
      # verify the required parameter 'user_id' is set
      fail ArgumentError, "Missing the required parameter 'user_id' when calling SupplierUserApi.patch" if user_id.nil?
      # verify the required parameter 'user' is set
      fail ArgumentError, "Missing the required parameter 'user' when calling SupplierUserApi.patch" if user.nil?
      # resource path
      local_var_path = "/suppliers/{supplierID}/users/{userID}".sub('{format}','json').sub('{' + 'supplierID' + '}', supplier_id.to_s).sub('{' + 'userID' + '}', user_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(user)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'User')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: SupplierUserApi#patch\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param supplier_id ID of the supplier.
    # @param user_id ID of the user.
    # @param user 
    # @param [Hash] opts the optional parameters
    # @return [User]
    def update(supplier_id, user_id, user, opts = {})
      data, _status_code, _headers = update_with_http_info(supplier_id, user_id, user, opts)
      return data
    end

    # 
    # 
    # @param supplier_id ID of the supplier.
    # @param user_id ID of the user.
    # @param user 
    # @param [Hash] opts the optional parameters
    # @return [Array<(User, Fixnum, Hash)>] User data, response status code and response headers
    def update_with_http_info(supplier_id, user_id, user, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: SupplierUserApi.update ..."
      end
      # verify the required parameter 'supplier_id' is set
      fail ArgumentError, "Missing the required parameter 'supplier_id' when calling SupplierUserApi.update" if supplier_id.nil?
      # verify the required parameter 'user_id' is set
      fail ArgumentError, "Missing the required parameter 'user_id' when calling SupplierUserApi.update" if user_id.nil?
      # verify the required parameter 'user' is set
      fail ArgumentError, "Missing the required parameter 'user' when calling SupplierUserApi.update" if user.nil?
      # resource path
      local_var_path = "/suppliers/{supplierID}/users/{userID}".sub('{format}','json').sub('{' + 'supplierID' + '}', supplier_id.to_s).sub('{' + 'userID' + '}', user_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(user)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'User')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: SupplierUserApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
