=begin
#OrderCloud

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0
Contact: ordercloud@four51.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require "uri"

module OrderCloud
  class UserGroupApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end

    # 
    # 
    # @param buyer_id ID of the buyer.
    # @param group 
    # @param [Hash] opts the optional parameters
    # @return [UserGroup]
    def create(buyer_id, group, opts = {})
      data, _status_code, _headers = create_with_http_info(buyer_id, group, opts)
      return data
    end

    # 
    # 
    # @param buyer_id ID of the buyer.
    # @param group 
    # @param [Hash] opts the optional parameters
    # @return [Array<(UserGroup, Fixnum, Hash)>] UserGroup data, response status code and response headers
    def create_with_http_info(buyer_id, group, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: UserGroupApi.create ..."
      end
      # verify the required parameter 'buyer_id' is set
      fail ArgumentError, "Missing the required parameter 'buyer_id' when calling UserGroupApi.create" if buyer_id.nil?
      # verify the required parameter 'group' is set
      fail ArgumentError, "Missing the required parameter 'group' when calling UserGroupApi.create" if group.nil?
      # resource path
      local_var_path = "/buyers/{buyerID}/usergroups".sub('{format}','json').sub('{' + 'buyerID' + '}', buyer_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(group)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'UserGroup')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserGroupApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param buyer_id ID of the buyer.
    # @param user_group_id ID of the user group.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete(buyer_id, user_group_id, opts = {})
      delete_with_http_info(buyer_id, user_group_id, opts)
      return nil
    end

    # 
    # 
    # @param buyer_id ID of the buyer.
    # @param user_group_id ID of the user group.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_with_http_info(buyer_id, user_group_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: UserGroupApi.delete ..."
      end
      # verify the required parameter 'buyer_id' is set
      fail ArgumentError, "Missing the required parameter 'buyer_id' when calling UserGroupApi.delete" if buyer_id.nil?
      # verify the required parameter 'user_group_id' is set
      fail ArgumentError, "Missing the required parameter 'user_group_id' when calling UserGroupApi.delete" if user_group_id.nil?
      # resource path
      local_var_path = "/buyers/{buyerID}/usergroups/{userGroupID}".sub('{format}','json').sub('{' + 'buyerID' + '}', buyer_id.to_s).sub('{' + 'userGroupID' + '}', user_group_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserGroupApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param buyer_id ID of the buyer.
    # @param user_group_id ID of the user group.
    # @param user_id ID of the user.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_user_assignment(buyer_id, user_group_id, user_id, opts = {})
      delete_user_assignment_with_http_info(buyer_id, user_group_id, user_id, opts)
      return nil
    end

    # 
    # 
    # @param buyer_id ID of the buyer.
    # @param user_group_id ID of the user group.
    # @param user_id ID of the user.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_user_assignment_with_http_info(buyer_id, user_group_id, user_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: UserGroupApi.delete_user_assignment ..."
      end
      # verify the required parameter 'buyer_id' is set
      fail ArgumentError, "Missing the required parameter 'buyer_id' when calling UserGroupApi.delete_user_assignment" if buyer_id.nil?
      # verify the required parameter 'user_group_id' is set
      fail ArgumentError, "Missing the required parameter 'user_group_id' when calling UserGroupApi.delete_user_assignment" if user_group_id.nil?
      # verify the required parameter 'user_id' is set
      fail ArgumentError, "Missing the required parameter 'user_id' when calling UserGroupApi.delete_user_assignment" if user_id.nil?
      # resource path
      local_var_path = "/buyers/{buyerID}/usergroups/{userGroupID}/assignments/{userID}".sub('{format}','json').sub('{' + 'buyerID' + '}', buyer_id.to_s).sub('{' + 'userGroupID' + '}', user_group_id.to_s).sub('{' + 'userID' + '}', user_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserGroupApi#delete_user_assignment\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param buyer_id ID of the buyer.
    # @param user_group_id ID of the user group.
    # @param [Hash] opts the optional parameters
    # @return [UserGroup]
    def get(buyer_id, user_group_id, opts = {})
      data, _status_code, _headers = get_with_http_info(buyer_id, user_group_id, opts)
      return data
    end

    # 
    # 
    # @param buyer_id ID of the buyer.
    # @param user_group_id ID of the user group.
    # @param [Hash] opts the optional parameters
    # @return [Array<(UserGroup, Fixnum, Hash)>] UserGroup data, response status code and response headers
    def get_with_http_info(buyer_id, user_group_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: UserGroupApi.get ..."
      end
      # verify the required parameter 'buyer_id' is set
      fail ArgumentError, "Missing the required parameter 'buyer_id' when calling UserGroupApi.get" if buyer_id.nil?
      # verify the required parameter 'user_group_id' is set
      fail ArgumentError, "Missing the required parameter 'user_group_id' when calling UserGroupApi.get" if user_group_id.nil?
      # resource path
      local_var_path = "/buyers/{buyerID}/usergroups/{userGroupID}".sub('{format}','json').sub('{' + 'buyerID' + '}', buyer_id.to_s).sub('{' + 'userGroupID' + '}', user_group_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'UserGroup')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserGroupApi#get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param buyer_id ID of the buyer.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :search Search of the user group.
    # @option opts [Array<String>] :search_on Search on of the user group.
    # @option opts [Array<String>] :sort_by Sort by of the user group.
    # @option opts [Integer] :page Page of the user group.
    # @option opts [Integer] :page_size Page size of the user group.
    # @option opts [Hash<String, String>] :filters Filters of the user group.
    # @return [ListUserGroup]
    def list(buyer_id, opts = {})
      data, _status_code, _headers = list_with_http_info(buyer_id, opts)
      return data
    end

    # 
    # 
    # @param buyer_id ID of the buyer.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :search Search of the user group.
    # @option opts [Array<String>] :search_on Search on of the user group.
    # @option opts [Array<String>] :sort_by Sort by of the user group.
    # @option opts [Integer] :page Page of the user group.
    # @option opts [Integer] :page_size Page size of the user group.
    # @option opts [Hash<String, String>] :filters Filters of the user group.
    # @return [Array<(ListUserGroup, Fixnum, Hash)>] ListUserGroup data, response status code and response headers
    def list_with_http_info(buyer_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: UserGroupApi.list ..."
      end
      # verify the required parameter 'buyer_id' is set
      fail ArgumentError, "Missing the required parameter 'buyer_id' when calling UserGroupApi.list" if buyer_id.nil?
      # resource path
      local_var_path = "/buyers/{buyerID}/usergroups".sub('{format}','json').sub('{' + 'buyerID' + '}', buyer_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'search'] = opts[:'search'] if !opts[:'search'].nil?
      query_params[:'searchOn'] = @api_client.build_collection_param(opts[:'search_on'], :csv) if !opts[:'search_on'].nil?
      query_params[:'sortBy'] = @api_client.build_collection_param(opts[:'sort_by'], :csv) if !opts[:'sort_by'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'pageSize'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'filters'] = opts[:'filters'] if !opts[:'filters'].nil?

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ListUserGroup')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserGroupApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param buyer_id ID of the buyer.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :user_group_id ID of the user group.
    # @option opts [String] :user_id ID of the user.
    # @option opts [Integer] :page Page of the user group.
    # @option opts [Integer] :page_size Page size of the user group.
    # @return [ListUserGroupAssignment]
    def list_user_assignments(buyer_id, opts = {})
      data, _status_code, _headers = list_user_assignments_with_http_info(buyer_id, opts)
      return data
    end

    # 
    # 
    # @param buyer_id ID of the buyer.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :user_group_id ID of the user group.
    # @option opts [String] :user_id ID of the user.
    # @option opts [Integer] :page Page of the user group.
    # @option opts [Integer] :page_size Page size of the user group.
    # @return [Array<(ListUserGroupAssignment, Fixnum, Hash)>] ListUserGroupAssignment data, response status code and response headers
    def list_user_assignments_with_http_info(buyer_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: UserGroupApi.list_user_assignments ..."
      end
      # verify the required parameter 'buyer_id' is set
      fail ArgumentError, "Missing the required parameter 'buyer_id' when calling UserGroupApi.list_user_assignments" if buyer_id.nil?
      # resource path
      local_var_path = "/buyers/{buyerID}/usergroups/assignments".sub('{format}','json').sub('{' + 'buyerID' + '}', buyer_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'userGroupID'] = opts[:'user_group_id'] if !opts[:'user_group_id'].nil?
      query_params[:'userID'] = opts[:'user_id'] if !opts[:'user_id'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'pageSize'] = opts[:'page_size'] if !opts[:'page_size'].nil?

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ListUserGroupAssignment')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserGroupApi#list_user_assignments\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param buyer_id ID of the buyer.
    # @param user_group_id ID of the user group.
    # @param group 
    # @param [Hash] opts the optional parameters
    # @return [UserGroup]
    def patch(buyer_id, user_group_id, group, opts = {})
      data, _status_code, _headers = patch_with_http_info(buyer_id, user_group_id, group, opts)
      return data
    end

    # 
    # 
    # @param buyer_id ID of the buyer.
    # @param user_group_id ID of the user group.
    # @param group 
    # @param [Hash] opts the optional parameters
    # @return [Array<(UserGroup, Fixnum, Hash)>] UserGroup data, response status code and response headers
    def patch_with_http_info(buyer_id, user_group_id, group, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: UserGroupApi.patch ..."
      end
      # verify the required parameter 'buyer_id' is set
      fail ArgumentError, "Missing the required parameter 'buyer_id' when calling UserGroupApi.patch" if buyer_id.nil?
      # verify the required parameter 'user_group_id' is set
      fail ArgumentError, "Missing the required parameter 'user_group_id' when calling UserGroupApi.patch" if user_group_id.nil?
      # verify the required parameter 'group' is set
      fail ArgumentError, "Missing the required parameter 'group' when calling UserGroupApi.patch" if group.nil?
      # resource path
      local_var_path = "/buyers/{buyerID}/usergroups/{userGroupID}".sub('{format}','json').sub('{' + 'buyerID' + '}', buyer_id.to_s).sub('{' + 'userGroupID' + '}', user_group_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(group)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'UserGroup')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserGroupApi#patch\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param buyer_id ID of the buyer.
    # @param user_group_assignment 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def save_user_assignment(buyer_id, user_group_assignment, opts = {})
      save_user_assignment_with_http_info(buyer_id, user_group_assignment, opts)
      return nil
    end

    # 
    # 
    # @param buyer_id ID of the buyer.
    # @param user_group_assignment 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def save_user_assignment_with_http_info(buyer_id, user_group_assignment, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: UserGroupApi.save_user_assignment ..."
      end
      # verify the required parameter 'buyer_id' is set
      fail ArgumentError, "Missing the required parameter 'buyer_id' when calling UserGroupApi.save_user_assignment" if buyer_id.nil?
      # verify the required parameter 'user_group_assignment' is set
      fail ArgumentError, "Missing the required parameter 'user_group_assignment' when calling UserGroupApi.save_user_assignment" if user_group_assignment.nil?
      # resource path
      local_var_path = "/buyers/{buyerID}/usergroups/assignments".sub('{format}','json').sub('{' + 'buyerID' + '}', buyer_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(user_group_assignment)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserGroupApi#save_user_assignment\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param buyer_id ID of the buyer.
    # @param user_group_id ID of the user group.
    # @param group 
    # @param [Hash] opts the optional parameters
    # @return [UserGroup]
    def update(buyer_id, user_group_id, group, opts = {})
      data, _status_code, _headers = update_with_http_info(buyer_id, user_group_id, group, opts)
      return data
    end

    # 
    # 
    # @param buyer_id ID of the buyer.
    # @param user_group_id ID of the user group.
    # @param group 
    # @param [Hash] opts the optional parameters
    # @return [Array<(UserGroup, Fixnum, Hash)>] UserGroup data, response status code and response headers
    def update_with_http_info(buyer_id, user_group_id, group, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: UserGroupApi.update ..."
      end
      # verify the required parameter 'buyer_id' is set
      fail ArgumentError, "Missing the required parameter 'buyer_id' when calling UserGroupApi.update" if buyer_id.nil?
      # verify the required parameter 'user_group_id' is set
      fail ArgumentError, "Missing the required parameter 'user_group_id' when calling UserGroupApi.update" if user_group_id.nil?
      # verify the required parameter 'group' is set
      fail ArgumentError, "Missing the required parameter 'group' when calling UserGroupApi.update" if group.nil?
      # resource path
      local_var_path = "/buyers/{buyerID}/usergroups/{userGroupID}".sub('{format}','json').sub('{' + 'buyerID' + '}', buyer_id.to_s).sub('{' + 'userGroupID' + '}', user_group_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json', 'text/plain; charset=utf-8']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(group)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'UserGroup')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserGroupApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
